// -------------------------------------------------------------------------------
// 
// 		cwCu		``ohvOwb_t@C
// 
// 				Ver 3.12c
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSAPIWIN_H__
#define __DXGRAPHICSAPIWIN_H__

// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include "../DxDirectX.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

struct GRAPHICSAPIINFO_WIN
{
	int						NotUseDirect3D11 ;						// cRcPPgpȂǂ

	HINSTANCE				Direct3D9DLL ;							// cRcXDckk
	D_IDirectDraw7			*DirectDraw7Object ;					// ccC^[tFCX
	D_IDirect3D9			*Direct3D9Object ;						// cRcXC^[tFCX
	D_IDirect3D9Ex			*Direct3D9ExObject ;					// cRcXdC^[tFCX
	D_IDirect3DDevice9		*Direct3DDevice9Object ;				// cRccXC^[tFCX
	D_IDirect3DDevice9Ex	*Direct3DDevice9ExObject ;				// cRccXdC^[tFCX
	D_IDirect3DSwapChain9	*Direct3DSwapChain9Object ;				// cRcrbXC^[tFCX

	HINSTANCE				Direct3D11DLL ;							// cRcPPDckk
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	HRESULT Direct3D9_ObjectRelease_ASync						( void *pObject, int ASyncThread = FALSE ) ;

extern	HRESULT	Direct3DDevice9_CreateRenderTarget_ASync			( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreateDepthStencilSurface_ASync		( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreateTexture_ASync					( UINT Width, UINT Height, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DTexture9** ppTexture, HANDLE* pSharedHandle, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreateCubeTexture_ASync				( UINT EdgeLength, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DCubeTexture9** ppCubeTexture, HANDLE* pSharedHandle, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_ColorFill_ASync						( D_IDirect3DSurface9* pSurface, CONST RECT* pRect, D_D3DCOLOR color, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreateOffscreenPlainSurface_ASync	( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_UpdateSurface_ASync					( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestinationSurface, CONST POINT* pDestPoint, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_UpdateTexture_ASync					( D_IDirect3DBaseTexture9* pSourceTexture, D_IDirect3DBaseTexture9* pDestinationTexture, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreateVertexShader_ASync			( CONST DWORD* pFunction, D_IDirect3DVertexShader9** ppShader, int ASyncThread ) ;
extern	HRESULT	Direct3DDevice9_CreatePixelShader_ASync				( CONST DWORD* pFunction, D_IDirect3DPixelShader9** ppShader, int ASyncThread ) ;
extern	int		Direct3DDevice9_CreateVertexBuffer_ASync			( DWORD Length, DWORD Usage, DWORD FVFFlag, D_D3DPOOL Pool, D_IDirect3DVertexBuffer9 **BufferP, int ASyncThread = FALSE ) ;		// _obt@쐬
extern	int		Direct3DDevice9_CreateIndexBuffer_ASync				( DWORD Length, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DIndexBuffer9 **BufferP, int ASyncThread = FALSE ) ;	// CfbNXobt@쐬

extern	HRESULT	Direct3DTexture9_GetSurfaceLevel_ASync				( D_IDirect3DTexture9 *Texture, UINT Level,  D_IDirect3DSurface9** ppSurfaceLevel, int ASyncThread ) ;
extern	HRESULT	Direct3DTexture9_LockRect_ASync						( D_IDirect3DTexture9 *Texture, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread ) ;
extern	HRESULT	Direct3DTexture9_UnlockRect_ASync					( D_IDirect3DTexture9 *Texture, UINT Level, int ASyncThread ) ;

extern	HRESULT Direct3DCubeTexture9_GetCubeMapSurface_ASync		( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_IDirect3DSurface9** ppCubeMapSurface, int ASyncThread) ;
extern	HRESULT Direct3DCubeTexture9_LockRect_ASync					( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread) ;
extern	HRESULT Direct3DCubeTexture9_UnlockRect_ASync				( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, int ASyncThread) ;

extern	HRESULT	Direct3DSurface9_LockRect_ASync						( D_IDirect3DSurface9* pSurface, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread ) ;
extern	HRESULT	Direct3DSurface9_UnlockRect_ASync					( D_IDirect3DSurface9* pSurface, int ASyncThread ) ;

extern	HRESULT	Direct3DVertexBuffer9_Lock_ASync					( D_IDirect3DVertexBuffer9 *Buffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags, int ASyncThread = FALSE ) ;
extern	HRESULT Direct3DVertexBuffer9_Unlock_ASync					( D_IDirect3DVertexBuffer9 *Buffer, int ASyncThread = FALSE ) ;

extern	HRESULT	Direct3DIndexBuffer9_Lock_ASync						( D_IDirect3DIndexBuffer9 *Buffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags, int ASyncThread = FALSE ) ;
extern	HRESULT Direct3DIndexBuffer9_Unlock_ASync					( D_IDirect3DIndexBuffer9 *Buffer, int ASyncThread = FALSE ) ;




extern	int		DirectDraw7_Create						( void ) ;
extern	int		DirectDraw7_Release						( void ) ;
extern	void *	DirectDraw7_GetObject					( void ) ;
extern	int		DirectDraw7_GetVideoMemorySize			( int *TotalSize, int *FreeSize ) ;


extern	ULONG	Direct3D9_ObjectRelease					( void *pObject ) ;


extern	int		Direct3D9_Create						( void ) ;
extern	int		Direct3D9_LoadDLL						( void ) ;
extern	int		Direct3D9_FreeDLL						( void ) ;
extern	ULONG	Direct3D9_Release						( void ) ;
extern	UINT	Direct3D9_GetAdapterCount				( void ) ;
extern	long	Direct3D9_GetAdapterIdentifier			( DWORD Adapter, DWORD Flags, D_D3DADAPTER_IDENTIFIER9* pIdentifier) ;
extern	UINT	Direct3D9_GetAdapterModeCount			( DWORD Adapter, D_D3DFORMAT Format) ;
extern	long	Direct3D9_EnumAdapterModes				( DWORD Adapter, D_D3DFORMAT Format, DWORD Mode,D_D3DDISPLAYMODE* pMode) ;
extern	long	Direct3D9_GetAdapterDisplayMode			( DWORD Adapter, D_D3DDISPLAYMODE* pMode) ;
extern	long	Direct3D9_CheckDeviceFormat				( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT AdapterFormat, DWORD Usage, D_D3DRESOURCETYPE RType, D_D3DFORMAT CheckFormat) ;
extern	long	Direct3D9_CheckDeviceMultiSampleType	( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT SurfaceFormat, BOOL Windowed, D_D3DMULTISAMPLE_TYPE MultiSampleType, DWORD* pQualityLevels) ;
extern	long	Direct3D9_CheckDepthStencilMatch		( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT AdapterFormat, D_D3DFORMAT RenderTargetFormat, D_D3DFORMAT DepthStencilFormat) ;
extern	long	Direct3D9_GetDeviceCaps					( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DCAPS9* pCaps) ;
extern	int		Direct3D9_CreateDevice					( void ) ;
extern	int		Direct3D9_CheckMultiSampleParam			( D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE *Samples, DWORD *Quality, int SamplesFailedBreak ) ;	// }`Tv_ÕTvƃNIeB`FbN
extern	int		Direct3D9_IsValid						( void ) ;
extern	int		Direct3D9_IsExObject					( void ) ;


extern	int		Direct3DDevice9_Release					( void ) ;
extern	UINT	Direct3DDevice9_GetAvailableTextureMem	( void ) ;
extern	long	Direct3DDevice9_GetDeviceCaps			( D_D3DCAPS9* pCaps) ;
extern	long	Direct3DDevice9_GetBackBuffer			( UINT iSwapChain, UINT iBackBuffer, D_D3DBACKBUFFER_TYPE Type, D_IDirect3DSurface9** ppBackBuffer ) ;
extern	long	Direct3DDevice9_SetDialogBoxMode		( BOOL bEnableDialogs) ;
extern	long	Direct3DDevice9_CreateTexture			( UINT Width, UINT Height, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DTexture9** ppTexture, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateVolumeTexture		( UINT Width, UINT Height, UINT Depth, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DVolumeTexture9** ppVolumeTexture, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateCubeTexture		( UINT EdgeLength, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DCubeTexture9** ppCubeTexture, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateVertexBuffer		( UINT Length, DWORD Usage, DWORD FVF, D_D3DPOOL Pool, D_IDirect3DVertexBuffer9** ppVertexBuffer, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateIndexBuffer		( UINT Length, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DIndexBuffer9** ppIndexBuffer, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateRenderTarget		( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_CreateDepthStencilSurface( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_UpdateSurface			( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestinationSurface, CONST POINT* pDestPoint) ;
extern	long	Direct3DDevice9_UpdateTexture			( D_IDirect3DBaseTexture9* pSourceTexture, D_IDirect3DBaseTexture9* pDestinationTexture) ;
extern	long	Direct3DDevice9_GetRenderTargetData		( D_IDirect3DSurface9* pRenderTarget, D_IDirect3DSurface9* pDestSurface) ;
extern	long	Direct3DDevice9_StretchRect				( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestSurface, CONST RECT* pDestRect, D_D3DTEXTUREFILTERTYPE Filter) ;
extern	long	Direct3DDevice9_ColorFill				( D_IDirect3DSurface9* pSurface, CONST RECT* pRect, D_D3DCOLOR color) ;
extern	long	Direct3DDevice9_CreateOffscreenPlainSurface( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle) ;
extern	long	Direct3DDevice9_SetRenderTarget			( DWORD RenderTargetIndex, D_IDirect3DSurface9* pRenderTarget) ;
extern	long	Direct3DDevice9_SetDepthStencilSurface	( D_IDirect3DSurface9* pNewZStencil) ;
extern	long	Direct3DDevice9_GetDepthStencilSurface	( D_IDirect3DSurface9** ppZStencilSurface) ;
extern	long	Direct3DDevice9_BeginScene				( void ) ;
extern	long	Direct3DDevice9_EndScene				( void ) ;
extern	long	Direct3DDevice9_Clear					( DWORD Count, CONST D_D3DRECT* pRects, DWORD Flags, D_D3DCOLOR Color, float Z, DWORD Stencil) ;
extern	long	Direct3DDevice9_SetTransform			( D_D3DTRANSFORMSTATETYPE State, CONST D_D3DMATRIX* pMatrix) ;
extern	long	Direct3DDevice9_SetViewport				( CONST D_D3DVIEWPORT9* pViewport) ;
extern	long	Direct3DDevice9_SetMaterial				( CONST D_D3DMATERIAL9* pMaterial) ;
extern	long	Direct3DDevice9_GetMaterial				( D_D3DMATERIAL9* pMaterial) ;
extern	long	Direct3DDevice9_SetLight				( DWORD Index, CONST D_D3DLIGHT9* Param ) ;
extern	long	Direct3DDevice9_LightEnable				( DWORD Index, BOOL Enable) ;
extern	long	Direct3DDevice9_SetRenderState			( D_D3DRENDERSTATETYPE State, DWORD Value ) ;
extern	long	Direct3DDevice9_SetTexture				( DWORD Stage, D_IDirect3DBaseTexture9* pTexture) ;
extern	long	Direct3DDevice9_SetTextureStageState	( DWORD Stage, D_D3DTEXTURESTAGESTATETYPE Type, DWORD Value) ;
extern	long	Direct3DDevice9_SetSamplerState			( DWORD Sampler, D_D3DSAMPLERSTATETYPE Type, DWORD Value ) ;
extern	long	Direct3DDevice9_SetScissorRect			( CONST RECT* pRect) ;
extern	long	Direct3DDevice9_DrawPrimitive			( D_D3DPRIMITIVETYPE PrimitiveType, UINT StartVertex, UINT PrimitiveCount ) ;
extern	long	Direct3DDevice9_DrawIndexedPrimitive	( D_D3DPRIMITIVETYPE PrimitiveType, INT BaseVertexIndex, UINT MinVertexIndex, UINT NumVertices, UINT startIndex, UINT primCount ) ;
extern	long	Direct3DDevice9_DrawPrimitiveUP			( D_D3DPRIMITIVETYPE PrimitiveType, UINT PrimitiveCount, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride ) ;
extern	long	Direct3DDevice9_DrawIndexedPrimitiveUP	( D_D3DPRIMITIVETYPE PrimitiveType, UINT MinVertexIndex, UINT NumVertices, UINT PrimitiveCount, CONST void* pIndexData, D_D3DFORMAT IndexDataFormat, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride ) ;
extern	long	Direct3DDevice9_CreateVertexDeclaration	( CONST D_D3DVERTEXELEMENT9* pVertexElements, D_IDirect3DVertexDeclaration9** ppDecl) ;
extern	long	Direct3DDevice9_SetVertexDeclaration	( D_IDirect3DVertexDeclaration9* pDecl ) ;
extern	long	Direct3DDevice9_SetFVF					( DWORD FVF ) ;
extern	long	Direct3DDevice9_CreateVertexShader		( CONST DWORD* pFunction, D_IDirect3DVertexShader9** ppShader) ;
extern	long	Direct3DDevice9_SetVertexShader			( D_IDirect3DVertexShader9* pShader) ;
extern	long	Direct3DDevice9_SetVertexShaderConstantF( UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount) ;
extern	long	Direct3DDevice9_SetVertexShaderConstantI( UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount) ;
extern	long	Direct3DDevice9_SetVertexShaderConstantB( UINT StartRegister, CONST BOOL* pConstantData, UINT  BoolCount) ;
extern	long	Direct3DDevice9_SetStreamSource			( UINT StreamNumber, D_IDirect3DVertexBuffer9* pStreamData, UINT OffsetInBytes, UINT Stride ) ;
extern	long	Direct3DDevice9_SetIndices				( D_IDirect3DIndexBuffer9* pIndexData ) ;
extern	long	Direct3DDevice9_CreatePixelShader		( CONST DWORD* pFunction, D_IDirect3DPixelShader9** ppShader) ;
extern	long	Direct3DDevice9_SetPixelShader			( D_IDirect3DPixelShader9* pShader) ;
extern	long	Direct3DDevice9_SetPixelShaderConstantF	( UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount) ;
extern	long	Direct3DDevice9_SetPixelShaderConstantI	( UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount) ;
extern	long	Direct3DDevice9_SetPixelShaderConstantB	( UINT StartRegister, CONST BOOL* pConstantData, UINT  BoolCount) ;
extern	int		Direct3DDevice9_Present					( void ) ;
extern	int		Direct3DDevice9_BltRectBackScreenToWindow( HWND Window, RECT BackScreenRect, RECT WindowClientRect ) ;
extern	void	Direct3DDevice9_WaitVSyncInitialize		( void ) ;
extern	void	Direct3DDevice9_LocalWaitVSync			( void ) ;
extern	int		Direct3DDevice9_WaitVSync				( int SyncNum ) ;
extern	int		Direct3DDevice9_IsValid					( void ) ;
extern	void *	Direct3DDevice9_GetObject				( void ) ;
extern	int		Direct3DDevice9_IsLost					( void ) ;
extern	int		Direct3DDevice9_SetupTimerPresent		( int EnableFlag ) ;


extern	long	Direct3DTexture9_GetSurfaceLevel		( D_IDirect3DTexture9 *pTexture, UINT Level, D_IDirect3DSurface9 ** ppSurfaceLevel) ;
extern	long	Direct3DTexture9_LockRect				( D_IDirect3DTexture9 *pTexture, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags) ;
extern	long	Direct3DTexture9_UnlockRect				( D_IDirect3DTexture9 *pTexture, UINT Level) ;

extern	long	Direct3DCubeTexture9_GetCubeMapSurface	( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_IDirect3DSurface9** ppCubeMapSurface) ;
extern	long	Direct3DCubeTexture9_LockRect			( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags) ;
extern	long	Direct3DCubeTexture9_UnlockRect			( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level) ;

extern	long	Direct3DSurface9_GetDesc				( D_IDirect3DSurface9 *pSurface, D_D3DSURFACE_DESC *pDesc) ;
extern	long	Direct3DSurface9_LockRect				( D_IDirect3DSurface9 *pSurface, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags) ;
extern	long	Direct3DSurface9_UnlockRect				( D_IDirect3DSurface9 *pSurface ) ;


extern	long	Direct3DVertexBuffer9_Lock				( D_IDirect3DVertexBuffer9 *pVertexBuffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags ) ;
extern	long	Direct3DVertexBuffer9_Unlock			( D_IDirect3DVertexBuffer9 *pVertexBuffer ) ;


extern	long	Direct3DIndexBuffer9_Lock				( D_IDirect3DIndexBuffer9 *pIndexBuffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags) ;
extern	long	Direct3DIndexBuffer9_Unlock				( D_IDirect3DIndexBuffer9 *pIndexBuffer ) ;

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXGRAPHICSAPIWIN_H__




