// -------------------------------------------------------------------------------
// 
// 		cwCu		WinAPIvO
// 
// 				Ver 3.12c
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxWinAPI.h"
#include <tchar.h>
#include "../DxASyncLoad.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

WINAPIDATA WinAPIData ;

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// WindowsOS  DLL ǂݍ
extern int LoadWinAPI( void )
{
#ifndef DX_NON_NETWORK
	// ws2_32.dll [h
	if( WinAPIData.WinSockFunc.WinSockDLL == NULL )
	{
		WinAPIData.WinSockFunc.WinSockDLL = LoadLibrary( _T( "ws2_32.dll" ) ) ;
		WinAPIData.WinSockFunc.WSAGetLastErrorFunc = ( int ( WINAPI * )( void ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "WSAGetLastError" ) ;
		WinAPIData.WinSockFunc.WSAStartupFunc = ( int ( WINAPI * )( WORD , LPWSADATA  ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "WSAStartup" ) ;
		WinAPIData.WinSockFunc.WSACleanupFunc = ( int ( WINAPI * )( void ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "WSACleanup" ) ;
		WinAPIData.WinSockFunc.WSAAsyncSelectFunc = ( int ( WINAPI * )( SOCKET, HWND, unsigned int, long ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "WSAAsyncSelect" ) ;
		WinAPIData.WinSockFunc.getaddrinfoFunc = ( int ( WINAPI * )( const char *, const char *, const _addrinfo *, _addrinfo ** ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "getaddrinfo" ) ;
		WinAPIData.WinSockFunc.gethostbyaddrFunc = ( struct hostent* ( WINAPI * )( const char *, int, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "gethostbyaddr" ) ;
		WinAPIData.WinSockFunc.gethostbynameFunc = ( struct hostent* ( WINAPI * )( const char * ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "gethostbyname" ) ;
		WinAPIData.WinSockFunc.gethostnameFunc = ( int ( WINAPI * )( char *name, int namelen ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "gethostname" ) ;
		WinAPIData.WinSockFunc.ntohsFunc = ( u_short ( WINAPI * )( u_short ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "ntohs" ) ;
		WinAPIData.WinSockFunc.htonsFunc = ( u_short ( WINAPI * )( u_short ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "htons" ) ;
		WinAPIData.WinSockFunc.connectFunc = ( int ( WINAPI * )( SOCKET s, const struct sockaddr *, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "connect" ) ;
		WinAPIData.WinSockFunc.socketFunc = ( SOCKET ( WINAPI * )( int, int, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "socket" ) ;
		WinAPIData.WinSockFunc.sendFunc = ( int ( WINAPI * )( SOCKET s, const char *, int, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "send" ) ;
		WinAPIData.WinSockFunc.sendtoFunc = ( int ( WINAPI * )( SOCKET s, const char *, int, int, const struct sockaddr *, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "sendto" ) ;
		WinAPIData.WinSockFunc.recvfromFunc = ( int ( WINAPI * )( SOCKET s, char *, int , int , struct sockaddr *, int * ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "recvfrom" ) ;
		WinAPIData.WinSockFunc.acceptFunc = ( SOCKET ( WINAPI * )( SOCKET s, struct sockaddr *, int * ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "accept" ) ;
		WinAPIData.WinSockFunc.closesocketFunc = ( int ( WINAPI * )( SOCKET ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "closesocket" ) ;
		WinAPIData.WinSockFunc.shutdownFunc = ( int ( WINAPI * )( SOCKET , int  ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "shutdown" ) ;
		WinAPIData.WinSockFunc.listenFunc = ( int ( WINAPI * )( SOCKET , int  ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "listen" ) ;
		WinAPIData.WinSockFunc.bindFunc = ( int ( WINAPI * )( SOCKET , const struct sockaddr *, int  ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "bind" ) ;
		WinAPIData.WinSockFunc.inet_addrFunc = ( unsigned long ( WINAPI * )( const char * ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "inet_addr" ) ;
		WinAPIData.WinSockFunc.recvFunc = ( int ( WINAPI * )( SOCKET, char *, int, int ) )GetProcAddress( WinAPIData.WinSockFunc.WinSockDLL, "recv" ) ;
	}
#endif

#ifndef DX_NON_KEYEX
	// Imm32DLL [h
	if( WinAPIData.ImmFunc.Imm32DLL == NULL )
	{
		WinAPIData.ImmFunc.Imm32DLL = LoadLibrary( _T( "Imm32.dll" ) ) ;
		WinAPIData.ImmFunc.ImmGetContextFunc = ( HIMC ( WINAPI * )( HWND  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetContext" ) ;
		WinAPIData.ImmFunc.ImmReleaseContextFunc = ( BOOL ( WINAPI * )( HWND , HIMC  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmReleaseContext" ) ;
		WinAPIData.ImmFunc.ImmGetOpenStatusFunc = ( BOOL ( WINAPI * )( HIMC  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetOpenStatus" ) ;
		WinAPIData.ImmFunc.ImmGetConversionStatusFunc = ( BOOL ( WINAPI * )( HIMC , LPDWORD , LPDWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetConversionStatus" ) ;
		WinAPIData.ImmFunc.ImmNotifyIMEFunc = ( BOOL ( WINAPI * )( HIMC , DWORD , DWORD , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmNotifyIME" ) ;
		WinAPIData.ImmFunc.ImmSetOpenStatusFunc = ( BOOL ( WINAPI * )( HIMC , BOOL  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmSetOpenStatus" ) ;

#ifdef UNICODE
		WinAPIData.ImmFunc.ImmGetCandidateListFunc = ( DWORD ( WINAPI * )( HIMC , DWORD , LPCANDIDATELIST , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCandidateListW" ) ;
		WinAPIData.ImmFunc.ImmGetCandidateListCountFunc = ( DWORD ( WINAPI * )( HIMC , LPDWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCandidateListCountW" ) ;
		WinAPIData.ImmFunc.ImmGetCompositionStringFunc = ( LONG ( WINAPI * )( HIMC , DWORD , LPVOID , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCompositionStringW" ) ;
		WinAPIData.ImmFunc.ImmSetCompositionStringFunc = ( BOOL ( WINAPI * )( HIMC , DWORD , LPCVOID , DWORD , LPCVOID , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmSetCompositionStringW" ) ;
#else
		WinAPIData.ImmFunc.ImmGetCandidateListFunc = ( DWORD ( WINAPI * )( HIMC , DWORD , LPCANDIDATELIST , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCandidateListA" ) ;
		WinAPIData.ImmFunc.ImmGetCandidateListCountFunc = ( DWORD ( WINAPI * )( HIMC , LPDWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCandidateListCountA" ) ;
		WinAPIData.ImmFunc.ImmGetCompositionStringFunc = ( LONG ( WINAPI * )( HIMC , DWORD , LPVOID , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmGetCompositionStringA" ) ;
		WinAPIData.ImmFunc.ImmSetCompositionStringFunc = ( BOOL ( WINAPI * )( HIMC , DWORD , LPCVOID , DWORD , LPCVOID , DWORD  ) )GetProcAddress( WinAPIData.ImmFunc.Imm32DLL, "ImmSetCompositionStringA" ) ;
#endif
	}
#endif

	// WinMM DLL [h
	if( WinAPIData.Win32Func.WinMMDLL == NULL )
	{
		WinAPIData.Win32Func.WinMMDLL = LoadLibrary( _T( "winmm.dll" ) ) ;
		WinAPIData.Win32Func.timeSetEventFunc = ( MMRESULT	( WINAPI * )( UINT , UINT , LPTIMECALLBACK , DWORD_PTR , UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeSetEvent" ) ;
		WinAPIData.Win32Func.timeKillEventFunc = ( MMRESULT ( WINAPI * )( UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeKillEvent" ) ;
		WinAPIData.Win32Func.timeBeginPeriodFunc = ( MMRESULT ( WINAPI * )( UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeBeginPeriod" ) ;
		WinAPIData.Win32Func.timeEndPeriodFunc = ( MMRESULT ( WINAPI * )( UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeEndPeriod" ) ;
		WinAPIData.Win32Func.timeGetTimeFunc = ( DWORD ( WINAPI * )( VOID ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeGetTime" ) ;
		WinAPIData.Win32Func.timeGetDevCapsFunc = ( MMRESULT ( WINAPI * )( LPTIMECAPS , UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "timeGetDevCaps" ) ;
		WinAPIData.Win32Func.joyGetPosExFunc = ( MMRESULT ( WINAPI * )( UINT , LPJOYINFOEX  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "joyGetPosEx" ) ;

#ifdef UNICODE
		WinAPIData.Win32Func.joyGetDevCapsFunc = ( MMRESULT ( WINAPI * )( UINT , LPJOYCAPS , UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "joyGetDevCapsW" ) ;
		WinAPIData.Win32Func.mciSendCommandFunc = ( MCIERROR ( WINAPI * )( MCIDEVICEID , UINT , DWORD_PTR , DWORD_PTR  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "mciSendCommandW" ) ;
#else
		WinAPIData.Win32Func.joyGetDevCapsFunc = ( MMRESULT ( WINAPI * )( UINT , LPJOYCAPS , UINT  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "joyGetDevCapsA" ) ;
		WinAPIData.Win32Func.mciSendCommandFunc = ( MCIERROR ( WINAPI * )( MCIDEVICEID , UINT , DWORD_PTR , DWORD_PTR  ) )GetProcAddress( WinAPIData.Win32Func.WinMMDLL, "mciSendCommandA" ) ;
#endif
	}

	// WinMM DLL [h
	if( WinAPIData.Win32Func.Old32DLL == NULL )
	{
		WinAPIData.Win32Func.Old32DLL = LoadLibrary( _T( "ole32.dll" ) ) ;
		WinAPIData.Win32Func.CoCreateInstanceFunc = ( HRESULT ( WINAPI * )( REFCLSID , IUnknown * , DWORD , REFIID , LPVOID * ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoCreateInstance" ) ;
		WinAPIData.Win32Func.CoTaskMemAllocFunc = ( LPVOID ( WINAPI * )( SIZE_T  ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoTaskMemAlloc" ) ;
		WinAPIData.Win32Func.CoTaskMemFreeFunc = ( void ( WINAPI * )( LPVOID  ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoTaskMemFree" ) ;
		WinAPIData.Win32Func.CoInitializeExFunc = ( HRESULT ( WINAPI * )( LPVOID, DWORD ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoInitializeEx" ) ;
		WinAPIData.Win32Func.CoFreeUnusedLibrariesFunc = ( void ( WINAPI * )( void ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoFreeUnusedLibraries" ) ;
		WinAPIData.Win32Func.CoUninitializeFunc = ( void ( WINAPI * )( void ) )GetProcAddress( WinAPIData.Win32Func.Old32DLL, "CoUninitialize" ) ;
	}

	// WinMM DLL [h
	if( WinAPIData.Win32Func.Comctl32DLL == NULL )
	{
		WinAPIData.Win32Func.Comctl32DLL = LoadLibrary( _T( "comctl32.dll" ) ) ;
		WinAPIData.Win32Func.InitCommonControlsFunc = ( void ( WINAPI * )( VOID ) )GetProcAddress( WinAPIData.Win32Func.Comctl32DLL, "InitCommonControls" ) ;
	}

	// DwmApiDLL [h
	if( WinAPIData.DwmApiDLL == NULL )
	{
		WinAPIData.DwmApiDLL = LoadLibrary( _T( "dwmapi.dll" ) ) ;
		WinAPIData.DF_DwmEnableComposition = ( HRESULT	( WINAPI * )( UINT ) )GetProcAddress( WinAPIData.DwmApiDLL, "DwmEnableComposition" ) ;
	}

	// User32DLL [h
	if( WinAPIData.User32DLL == NULL )
	{
		WinAPIData.User32DLL = LoadLibrary( _T( "User32.dll" ) ) ;
		WinAPIData.WINNLSEnableIME_Func = ( BOOL ( WINAPI * )( HWND, BOOL ) )GetProcAddress( WinAPIData.User32DLL, "WINNLSEnableIME" ) ;
	}

	// I
	return 0 ;
}

// WindowsOS  DLL 
extern int ReleaseWinAPI( void )
{
	// DWMAPI.DLL ̉
	if( WinAPIData.DwmApiDLL )
	{
		FreeLibrary( WinAPIData.DwmApiDLL ) ;
		WinAPIData.DwmApiDLL = NULL ;
		WinAPIData.DF_DwmEnableComposition = NULL ;
	}

	// User32.DLL ̉
	if( WinAPIData.User32DLL )
	{
		FreeLibrary( WinAPIData.User32DLL ) ;
		WinAPIData.User32DLL = NULL ;
		WinAPIData.WINNLSEnableIME_Func = NULL ;
	}

#ifndef DX_NON_NETWORK
	// ws2_32.dll ̉
	if( WinAPIData.WinSockFunc.WinSockDLL )
	{
		FreeLibrary( WinAPIData.WinSockFunc.WinSockDLL ) ;
		WinAPIData.WinSockFunc.WinSockDLL = NULL ;
		WinAPIData.WinSockFunc.WSAGetLastErrorFunc = NULL ;
		WinAPIData.WinSockFunc.WSAStartupFunc = NULL ;
		WinAPIData.WinSockFunc.WSACleanupFunc = NULL ;
		WinAPIData.WinSockFunc.WSAAsyncSelectFunc = NULL ;
		WinAPIData.WinSockFunc.getaddrinfoFunc = NULL ;
		WinAPIData.WinSockFunc.gethostbyaddrFunc = NULL ;
		WinAPIData.WinSockFunc.gethostbynameFunc = NULL ;
		WinAPIData.WinSockFunc.gethostnameFunc = NULL ;
		WinAPIData.WinSockFunc.ntohsFunc = NULL ;
		WinAPIData.WinSockFunc.htonsFunc = NULL ;
		WinAPIData.WinSockFunc.connectFunc = NULL ;
		WinAPIData.WinSockFunc.socketFunc = NULL ;
		WinAPIData.WinSockFunc.sendFunc = NULL ;
		WinAPIData.WinSockFunc.sendtoFunc = NULL ;
		WinAPIData.WinSockFunc.recvfromFunc = NULL ;
		WinAPIData.WinSockFunc.acceptFunc = NULL ;
		WinAPIData.WinSockFunc.closesocketFunc = NULL ;
		WinAPIData.WinSockFunc.shutdownFunc = NULL ;
		WinAPIData.WinSockFunc.listenFunc = NULL ;
		WinAPIData.WinSockFunc.bindFunc = NULL ;
		WinAPIData.WinSockFunc.inet_addrFunc = NULL ;
		WinAPIData.WinSockFunc.recvFunc = NULL ;
	}
#endif

#ifndef DX_NON_KEYEX
	// Imm32DLL 
	if( WinAPIData.ImmFunc.Imm32DLL )
	{
		FreeLibrary( WinAPIData.ImmFunc.Imm32DLL ) ;
		WinAPIData.ImmFunc.Imm32DLL = NULL ;
		WinAPIData.ImmFunc.ImmGetContextFunc = NULL ;
		WinAPIData.ImmFunc.ImmReleaseContextFunc = NULL ;
		WinAPIData.ImmFunc.ImmGetOpenStatusFunc = NULL ;
		WinAPIData.ImmFunc.ImmGetConversionStatusFunc = NULL ;
		WinAPIData.ImmFunc.ImmNotifyIMEFunc = NULL ;
		WinAPIData.ImmFunc.ImmSetOpenStatusFunc = NULL ;

		WinAPIData.ImmFunc.ImmGetCandidateListFunc = NULL ;
		WinAPIData.ImmFunc.ImmGetCompositionStringFunc = NULL ;
		WinAPIData.ImmFunc.ImmSetCompositionStringFunc = NULL ;
	}
#endif

	// WinMM DLL 
	if( WinAPIData.Win32Func.WinMMDLL )
	{
		FreeLibrary( WinAPIData.Win32Func.WinMMDLL ) ;
		WinAPIData.Win32Func.WinMMDLL = NULL ;
		WinAPIData.Win32Func.timeSetEventFunc = NULL ;
		WinAPIData.Win32Func.timeKillEventFunc = NULL ;
		WinAPIData.Win32Func.timeBeginPeriodFunc = NULL ;
		WinAPIData.Win32Func.timeEndPeriodFunc = NULL ;
		WinAPIData.Win32Func.timeGetTimeFunc = NULL ;
		WinAPIData.Win32Func.timeGetDevCapsFunc = NULL ;
		WinAPIData.Win32Func.joyGetPosExFunc = NULL ;

		WinAPIData.Win32Func.joyGetDevCapsFunc = NULL ;
		WinAPIData.Win32Func.mciSendCommandFunc = NULL ;
	}

	// Ole32 DLL 
	if( WinAPIData.Win32Func.Old32DLL )
	{
		FreeLibrary( WinAPIData.Win32Func.Old32DLL ) ;
		WinAPIData.Win32Func.Old32DLL = NULL ;
		WinAPIData.Win32Func.CoCreateInstanceFunc = NULL ;
		WinAPIData.Win32Func.CoTaskMemAllocFunc = NULL ;
		WinAPIData.Win32Func.CoTaskMemFreeFunc = NULL ;
		WinAPIData.Win32Func.CoInitializeExFunc = NULL ;
		WinAPIData.Win32Func.CoFreeUnusedLibrariesFunc = NULL ;
		WinAPIData.Win32Func.CoUninitializeFunc = NULL ;
	}

	// WinMM DLL 
	if( WinAPIData.Win32Func.Comctl32DLL )
	{
		FreeLibrary( WinAPIData.Win32Func.Comctl32DLL ) ;
		WinAPIData.Win32Func.Comctl32DLL = NULL ;
		WinAPIData.Win32Func.InitCommonControlsFunc = NULL ;
	}

	// I
	return 0 ;
}













#ifndef DX_NON_ASYNCLOAD
extern int WinAPI_CoCreateInstance_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	GUID rclsid ;
	GUID riid ;

	rclsid.Data1 = ( unsigned long )Info->Data[ 0 ] ;
	rclsid.Data2 = ( short )( Info->Data[ 1 ] & 0xffff ) ;
	rclsid.Data3 = ( short )( ( Info->Data[ 1 ] >> 16 ) & 0xffff ) ;
	rclsid.Data4[ 0 ] = ( char )(   Info->Data[ 2 ]         & 0xff ) ;
	rclsid.Data4[ 1 ] = ( char )( ( Info->Data[ 2 ] >>  8 ) & 0xff ) ;
	rclsid.Data4[ 2 ] = ( char )( ( Info->Data[ 2 ] >> 16 ) & 0xff ) ;
	rclsid.Data4[ 3 ] = ( char )( ( Info->Data[ 2 ] >> 24 ) & 0xff ) ;
	rclsid.Data4[ 4 ] = ( char )(   Info->Data[ 3 ]         & 0xff ) ;
	rclsid.Data4[ 5 ] = ( char )( ( Info->Data[ 3 ] >>  8 ) & 0xff ) ;
	rclsid.Data4[ 6 ] = ( char )( ( Info->Data[ 3 ] >> 16 ) & 0xff ) ;
	rclsid.Data4[ 7 ] = ( char )( ( Info->Data[ 3 ] >> 24 ) & 0xff ) ;

	riid.Data1 = ( unsigned long )Info->Data[ 6 ] ;
	riid.Data2 = ( short )( Info->Data[ 7 ] & 0xffff ) ;
	riid.Data3 = ( short )( ( Info->Data[ 7 ] >> 16 ) & 0xffff ) ;
	riid.Data4[ 0 ] = ( char )(   Info->Data[ 8 ]         & 0xff ) ;
	riid.Data4[ 1 ] = ( char )( ( Info->Data[ 8 ] >>  8 ) & 0xff ) ;
	riid.Data4[ 2 ] = ( char )( ( Info->Data[ 8 ] >> 16 ) & 0xff ) ;
	riid.Data4[ 3 ] = ( char )( ( Info->Data[ 8 ] >> 24 ) & 0xff ) ;
	riid.Data4[ 4 ] = ( char )(   Info->Data[ 9 ]         & 0xff ) ;
	riid.Data4[ 5 ] = ( char )( ( Info->Data[ 9 ] >>  8 ) & 0xff ) ;
	riid.Data4[ 6 ] = ( char )( ( Info->Data[ 9 ] >> 16 ) & 0xff ) ;
	riid.Data4[ 7 ] = ( char )( ( Info->Data[ 9 ] >> 24 ) & 0xff ) ;

	return WinAPI_CoCreateInstance_ASync(
		rclsid,
		( IUnknown * )Info->Data[ 4 ],
		( DWORD )Info->Data[ 5 ],
		riid,
		( LPVOID * )Info->Data[ 10 ],
		FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT WinAPI_CoCreateInstance_ASync( REFCLSID rclsid, IUnknown * pUnkOuter, DWORD dwClsContext, REFIID riid, LPVOID *ppv, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = WinAPI_CoCreateInstance_ASyncCallback ;
		AInfo.Data[  0 ] = ( DWORD_PTR )rclsid.Data1 ;
		AInfo.Data[  1 ] = ( DWORD_PTR )( rclsid.Data2 | ( ( ( DWORD )rclsid.Data3 ) ) << 16 );
		AInfo.Data[  2 ] = ( DWORD_PTR )( rclsid.Data4[ 0 ] | ( ( ( DWORD )rclsid.Data4[ 1 ] ) << 8 ) | ( ( ( DWORD )rclsid.Data4[ 2 ] ) << 16 ) | ( ( ( DWORD )rclsid.Data4[ 3 ] ) << 24 ) ) ;
		AInfo.Data[  3 ] = ( DWORD_PTR )( rclsid.Data4[ 4 ] | ( ( ( DWORD )rclsid.Data4[ 5 ] ) << 8 ) | ( ( ( DWORD )rclsid.Data4[ 6 ] ) << 16 ) | ( ( ( DWORD )rclsid.Data4[ 7 ] ) << 24 ) ) ;
		AInfo.Data[  4 ] = ( DWORD_PTR )pUnkOuter ;
		AInfo.Data[  5 ] = ( DWORD_PTR )dwClsContext ;
		AInfo.Data[  6 ] = ( DWORD_PTR )riid.Data1 ;
		AInfo.Data[  7 ] = ( DWORD_PTR )( riid.Data2 | ( ( ( DWORD )riid.Data3 ) ) << 16 );
		AInfo.Data[  8 ] = ( DWORD_PTR )( riid.Data4[ 0 ] | ( ( ( DWORD )riid.Data4[ 1 ] ) << 8 ) | ( ( ( DWORD )riid.Data4[ 2 ] ) << 16 ) | ( ( ( DWORD )riid.Data4[ 3 ] ) << 24 ) ) ;
		AInfo.Data[  9 ] = ( DWORD_PTR )( riid.Data4[ 4 ] | ( ( ( DWORD )riid.Data4[ 5 ] ) << 8 ) | ( ( ( DWORD )riid.Data4[ 6 ] ) << 16 ) | ( ( ( DWORD )riid.Data4[ 7 ] ) << 24 ) ) ;
		AInfo.Data[ 10 ] = ( DWORD_PTR )ppv ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return WinAPIData.Win32Func.CoCreateInstanceFunc( rclsid, pUnkOuter, dwClsContext, riid, ppv );
}


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

