// -------------------------------------------------------------------------------
// 
// 		cwCu		WbCugpvOwb_t@C
// 
// 				Ver 3.12c
// 
// -------------------------------------------------------------------------------

#ifndef __DXUSECLIB_H__
#define __DXUSECLIB_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_OGGTHEORA
#include "DxMovie.h"
#endif

#if !defined( DX_NON_OGGVORBIS ) || !defined( DX_NON_MOVIE )
#include "DxSoundConvert.h"
#endif

#include "DxFile.h"
#include "DxBaseFunc.h"

//namespace DxLib
//{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------





extern	int			_VSWPRINTF( DXWCHAR *Buffer, const DXWCHAR *FormatString, va_list Arg ) ; // ̂ DxUseCLib.cpp ̒





#ifndef DX_NON_MERSENNE_TWISTER

// Copyright SYN
extern unsigned long	CheckMMX(void) ;
extern void				srandMT(unsigned long seed) ;
extern void				generateMT(void) ;
extern unsigned long	randMT(void) ;

#endif // DX_NON_MERSENNE_TWISTER






#ifndef DX_NON_TIFFREAD
extern	int		LoadTiffImage( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;										// shee摜̓ǂ݂
#endif
#ifndef DX_NON_PNGREAD
extern	int		LoadPngImage( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;											// omf摜̓ǂ݂
#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveBaseImageToPngBase( const DXWCHAR *FilePathW, const char *FilePathA, BASEIMAGE *BaseImage, int CompressionLevel ) ;																					// {摜f[^omf摜Ƃĕۑ
#endif
#endif
#ifndef DX_NON_JPEGREAD
extern	int		LoadJpegImage( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;										// iodf摜̓ǂ݂ (̂ DxUseCLib.cpp ̒)
#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveBaseImageToJpegBase( const DXWCHAR *FilePathW, const char *FilePathA, BASEIMAGE *BaseImage, int Quality, int Sample2x1 ) ;																			// {摜f[^iodf摜Ƃĕۑ
#endif
#endif



extern	int			FileRead_scanf_base( DWORD_PTR FileHandle, const char *Format, va_list Param ) ;		// t@C珑ꂽf[^ǂݏo
extern	int			FileRead_scanf_baseW( DWORD_PTR FileHandle, const DXWCHAR *Format, va_list Param ) ;	// t@C珑ꂽf[^ǂݏo



#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
extern	int SetupSoundConvert_DSMP3(            SOUNDCONV *SoundConv ) ;							// DirectShowgMP3t@CRo[gZbgAbvs( [] -1:G[ )
#endif
#endif
#endif




#ifndef DX_NON_OGGVORBIS
extern	int SetupSoundConvert_OGG(            SOUNDCONV *SoundConv ) ;								// nfft@C̃ZbgAbvs( [] -1:G[ )
extern	int TerminateSoundConvert_OGG(        SOUNDCONV *SoundConv ) ;								// nfft@Čns
extern	int ConvertProcessSoundConvert_OGG(   SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//extern	int SetTimeSoundConvert_OGG(      SOUNDCONV *SoundConv, int Time ) ;					// ϊʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert_OGG(    SOUNDCONV *SoundConv, int SampleTime ) ;				// ϊ̈ʒuύX( TvP )
extern	int GetSoundConvertDestSize_Fast_OGG( SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂
#endif




#ifndef DX_NON_OGGTHEORA

extern int	TheoraDecode_GrobalInitialize( void ) ;																					// \tgIɈxĂԂׂ֐

extern DWORD_PTR  TheoraDecode_InitializeStream( STREAMDATASHREDTYPE2 *StreamShred, DWORD_PTR StreamData, int StockFrameNum = 10, int NotUseYUVFormatSurface = FALSE, int ASyncTrhead = FALSE ) ;	// Ogg Theora ǂݍݏ̏s( ߂l  0:s  1ȏ: )
extern int	TheoraDecode_Terminate( DWORD_PTR Handle ) ;																			// Ogg Theora ǂݍݏ̌ns
extern int	TheoraDecode_SurfaceTerminate( DWORD_PTR Handle ) ;																		// Ogg Theora ŎgpĂT[tFX

extern int	TheoraDecode_GetInfo( DWORD_PTR Handle, THEORADECODE_INFO *Info ) ;														// ̏擾
extern int	TheoraDecode_GetCurrentFrame( DWORD_PTR Handle ) ;																		// Jgt[擾
	
extern int	TheoraDecode_IncToFrame( DWORD_PTR Handle, int AddNum = 1 ) ;															// Jgt[Pt[i߂( ߂l  0:L[t[Ȃ  1:L[t[  -1:G[ )
extern int	TheoraDecode_SeekToFrame( DWORD_PTR Handle, int Frame ) ;																// Jgt[w̃t[Ɉړ
extern int	TheoraDecode_SeekToTime( DWORD_PTR Handle, LONGLONG Time ) ;															// Jgt[w̍ĐԂɈړ( Pʂ̓}CNb )

extern int	TheoraDecode_SetupImage( DWORD_PTR Handle, int BaseImage = 0, int YUVImage = 0, int ASyncThread = FALSE ) ;				// Jgt[RGB摜쐬( ߂l  1:쐬ꂽ  0:Ȃ )
extern const BASEIMAGE           *TheoraDecode_GetBaseImage( DWORD_PTR Handle ) ;													// ꎞobt@̃AhX擾
extern const D_IDirect3DSurface9 *TheoraDecode_GetYUVImage( DWORD_PTR Handle ) ;													// ꎞobt@ YUV tH[}bg̃T[tFX𓾂

extern int	TheoraDecode_IsIdle( DWORD_PTR Handle ) ;																				// fR[hXbhAChԂǂ𒲂ׂ( ߂l  1:ACh  0:ғ )

#endif







//}

#endif // __DXUSECLIB_H__
