//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowspGraphFilternvO
// 
//  	Ver 3.12c
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsFilterWin.h"
#include "DxGraphicsFilterD3D9.h"

#ifndef DX_NON_FILTER

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// ˑ֌W

extern int	GraphFilter_Mono_PF(       GRAPHFILTER_INFO *Info, float Cb, float Cr )
{
	return GraphFilter_D3D9_Mono_PF(       Info,  Cb,  Cr ) ;
}

extern int	GraphFilter_Gauss_PF(      GRAPHFILTER_INFO *Info, int PixelWidth, float Param, float *Table )
{
	return GraphFilter_D3D9_Gauss_PF(      Info,  PixelWidth,  Param, Table ) ;
}

extern int	GraphFilter_Down_Scale_PF(  GRAPHFILTER_INFO *Info, int DivNum )
{
	return GraphFilter_D3D9_Down_Scale_PF(  Info,  DivNum ) ;
}

extern int	GraphFilter_Bright_Clip_PF( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor )
{
	return GraphFilter_D3D9_Bright_Clip_PF( Info,  CmpType,  CmpParam,  ClipFillFlag, ClipFillColor ) ;
}

extern int	GraphFilter_HSB_PF(         GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright )
{
	return GraphFilter_D3D9_HSB_PF(         Info,  HueType,  Hue,  Saturation,  Bright ) ;
}

extern int	GraphFilter_Invert_PF(      GRAPHFILTER_INFO *Info )
{
	return GraphFilter_D3D9_Invert_PF(      Info ) ;
}

extern int	GraphFilter_Level_PF(       GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax )
{
	return GraphFilter_D3D9_Level_PF(       Info,  Min,  Max,  Gamma,  AfterMin,  AfterMax ) ;
}

extern int	GraphFilter_TwoColor_PF(    GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor )
{
	return GraphFilter_D3D9_TwoColor_PF(    Info,  Threshold, LowColor, HighColor ) ;
}

extern int	GraphFilter_GradientMap_PF( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse )
{
	return GraphFilter_D3D9_GradientMap_PF( Info,  MapGrHandle,  Reverse ) ;
}

extern int	GraphFilter_PremulAlpha_PF( GRAPHFILTER_INFO *Info )
{
	return GraphFilter_D3D9_PremulAlpha_PF( Info ) ;
}

extern int	GraphFilter_InterpAlpha_PF( GRAPHFILTER_INFO *Info )
{
	return GraphFilter_D3D9_InterpAlpha_PF( Info ) ;
}

// 摜̃tB^[t]s( ψt )
extern int	GraphFilter_RectBltBase_PF( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int DestX, int DestY, va_list ParamList )
{
	return GraphFilter_D3D9_RectBltBase_PF(  IsBlend,  SrcGrHandle,  BlendGrHandle,  DestGrHandle,  BlendRatio,  FilterOrBlendType,  SrcX1,  SrcY1,  SrcX2,  SrcY2,  BlendX,  BlendY,  BlendPosEnable,  DestX,  DestY, ParamList ) ;
}


extern int	GraphBlend_Basic_PF(           GRAPHFILTER_INFO *Info )
{
	return GraphBlend_D3D9_Basic_PF(           Info ) ;
}

extern int	GraphBlend_RGBA_Select_Mix_PF( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA )
{
	return GraphBlend_D3D9_RGBA_Select_Mix_PF( Info,  SelectR,  SelectG,  SelectB,  SelectA ) ;
}



#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_FILTER


